/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#ifndef _MAINWIN_H_
#define _MAINWIN_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/mdi.h"
////@end includes

//#include <wx/aui/aui.h>
#include "cameracontroller.h"
#include "camdialog.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxMenu;
////@end forward declarations


/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_MAINWIN 10000
#define ID_MENU_EXIT 10002
#define ID_MENU_START_BALLON 10017
#define ID_MENU_START_PVOICE 10018
#define ID_MENUITEM_VIRTUAL_INSTRUMENT 10085
#define ID_MENUITEM_CONFIG_AUDIO 10050
#define ID_MENUITEM_CAMERA 10066
#define ID_MENUITEM_MIDI 10075
#define ID_MENUITEM_ABOUT 10031
#define SYMBOL_MAINWIN_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX
#define SYMBOL_MAINWIN_TITLE _("SITPLUS")
#define SYMBOL_MAINWIN_IDNAME ID_MAINWIN
#define SYMBOL_MAINWIN_SIZE wxSize(800, 600)
#define SYMBOL_MAINWIN_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * MainWin class declaration
 */

class MainWin: public wxMDIParentFrame
{    
    DECLARE_CLASS( MainWin )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    MainWin();
    MainWin( wxWindow* parent, wxWindowID id = SYMBOL_MAINWIN_IDNAME, const wxString& caption = SYMBOL_MAINWIN_TITLE, const wxPoint& pos = SYMBOL_MAINWIN_POSITION, const wxSize& size = SYMBOL_MAINWIN_SIZE, long style = SYMBOL_MAINWIN_STYLE );

    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_MAINWIN_IDNAME, const wxString& caption = SYMBOL_MAINWIN_TITLE, const wxPoint& pos = SYMBOL_MAINWIN_POSITION, const wxSize& size = SYMBOL_MAINWIN_SIZE, long style = SYMBOL_MAINWIN_STYLE );

    /// Destructor
    ~MainWin();

private:
    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

	virtual bool ProcessEvent(wxEvent& event);

////@begin MainWin event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_MAINWIN
    void OnCloseWindow( wxCloseEvent& event );

    /// wxEVT_DESTROY event handler for ID_MAINWIN
    void OnDestroy( wxWindowDestroyEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU_EXIT
    void OnMenuExitClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU_START_BALLON
    void OnMenuStartBallonClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENU_START_PVOICE
    void OnMenuStartPvoiceClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUITEM_VIRTUAL_INSTRUMENT
    void OnMenuitemVirtualInstrumentClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUITEM_CONFIG_AUDIO
    void OnMenuitemConfigAudioClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUITEM_CAMERA
    void OnMenuitemCameraClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUITEM_MIDI
    void OnMenuitemMidiClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_MENU_SELECTED event handler for ID_MENUITEM_ABOUT
    void OnMenuitemAboutClick( wxCommandEvent& event );

////@end MainWin event handler declarations

	void OnShouldOpenCam ( wxCommandEvent& event );
	void OnShouldCloseCam ( wxCommandEvent& event );
	void OnCameraError ( wxCommandEvent& event );

////@begin MainWin member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end MainWin member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin MainWin member variables
    wxMenu* m_menuActivity;
    wxMenu* m_menuConfiguration;
////@end MainWin member variables

	//CCamDialog* m_camDialog;
	wxWindow* m_camDialog;
};

#endif
    // _MAINWIN_H_
