/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

////@begin includes
////@end includes

#include "playwithvoicedialog.h"
#include "pvoiceactivity.h"
#include "vumeter.h"

////@begin XPM images
#include "bitmaps/disable_icon.xpm"
////@end XPM images


/*!
 * PlayWithVoiceDialog type definition
 */

IMPLEMENT_DYNAMIC_CLASS( PlayWithVoiceDialog, wxMDIChildFrame )


/*!
 * PlayWithVoiceDialog event table definition
 */

BEGIN_EVENT_TABLE( PlayWithVoiceDialog, wxMDIChildFrame )

////@begin PlayWithVoiceDialog event table entries
    EVT_CLOSE( PlayWithVoiceDialog::OnCloseWindow )
    EVT_WINDOW_DESTROY( PlayWithVoiceDialog::OnDestroy )

    EVT_BUTTON( ID_BITMAPBUTTON_MICINPUT, PlayWithVoiceDialog::OnBitmapbuttonMicinputClick )

    EVT_SLIDER( ID_SLIDER_MIC_INPUT, PlayWithVoiceDialog::OnSliderMicInputUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_SOUNDOUTPUT, PlayWithVoiceDialog::OnBitmapbuttonSoundoutputClick )

    EVT_SLIDER( ID_SLIDER_OUTPUT, PlayWithVoiceDialog::OnSliderOutputUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_REVERB, PlayWithVoiceDialog::OnBitmapbuttonReverbClick )

    EVT_SLIDER( ID_SLIDER_REVERB, PlayWithVoiceDialog::OnSliderReverbUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_CHORUS, PlayWithVoiceDialog::OnBitmapbuttonChorusClick )

    EVT_SLIDER( ID_SLIDER_CHORUS, PlayWithVoiceDialog::OnSliderChorusUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_PITCHSHIFT, PlayWithVoiceDialog::OnBitmapbuttonPitchshiftClick )

    EVT_SLIDER( ID_SLIDER_PITCHSHIFT, PlayWithVoiceDialog::OnSliderPitchshiftUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_DISTORSION, PlayWithVoiceDialog::OnBitmapbuttonDistorsionClick )

    EVT_SLIDER( ID_SLIDER_DISTORSION, PlayWithVoiceDialog::OnSliderDistorsionUpdated )

    EVT_CHECKBOX( ID_CHECKBOX_ROBOT, PlayWithVoiceDialog::OnCheckboxRobotClick )

    EVT_CHECKBOX( ID_CHECKBOX_PHONE, PlayWithVoiceDialog::OnCheckboxPhoneClick )

    EVT_CHECKBOX( ID_CHECKBOX_HOWLINGREDUCTION, PlayWithVoiceDialog::OnCheckboxHowlingreductionClick )

    EVT_BUTTON( ID_BITMAPBUTTON_ECHODELAY, PlayWithVoiceDialog::OnBitmapbuttonEchodelayClick )

    EVT_SLIDER( ID_SLIDER_ECHODELAY, PlayWithVoiceDialog::OnSliderEchodelayUpdated )

    EVT_BUTTON( ID_BITMAPBUTTON_ECHOPITCHSHIFT, PlayWithVoiceDialog::OnBitmapbuttonEchopitchshiftClick )

    EVT_SLIDER( ID_SLIDER_ECHOPITCHSHIFT, PlayWithVoiceDialog::OnSliderEchopitchshiftUpdated )

////@end PlayWithVoiceDialog event table entries

	EVT_TIMER(TIMER_ID, PlayWithVoiceDialog::OnTimer)

END_EVENT_TABLE()

PlayWithVoiceDialog* PlayWithVoiceDialog::g_single= NULL;
PlayWithVoiceDialog* PlayWithVoiceDialog::getInstance(wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style)
{
	if (g_single== NULL) {
		g_single= new PlayWithVoiceDialog( parent, id, caption, pos, size, style);
	}
	return g_single;
}


/*!
 * PlayWithVoiceDialog constructors
 */

PlayWithVoiceDialog::PlayWithVoiceDialog()  
//: m_timer(this, TIMER_ID)
{
    Init();
}

//PlayWithVoiceDialog::PlayWithVoiceDialog( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )  
PlayWithVoiceDialog::PlayWithVoiceDialog( wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style)
//: m_timer(this, TIMER_ID)
{
    Init();
    Create(parent, id, caption, pos, size, style);
}


/*!
 * PlayWithVoiceDialog creator
 */
    
//bool PlayWithVoiceDialog::Create( wxWindow* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
bool PlayWithVoiceDialog::Create( wxMDIParentFrame* parent, wxWindowID id, const wxString& caption, const wxPoint& pos, const wxSize& size, long style )
{
////@begin PlayWithVoiceDialog creation
    SetExtraStyle(wxWS_EX_BLOCK_EVENTS);
    wxMDIChildFrame::Create( parent, id, caption, pos, size, style );

    CreateControls();
    if (GetSizer())
    {
        GetSizer()->SetSizeHints(this);
    }
////@end PlayWithVoiceDialog creation
    return true;
}


/*!
 * PlayWithVoiceDialog destructor
 */

PlayWithVoiceDialog::~PlayWithVoiceDialog()
{
	g_single= NULL;
	if (m_timer) delete m_timer;
	m_timer= NULL;
////@begin PlayWithVoiceDialog destruction
////@end PlayWithVoiceDialog destruction
	if (m_activity) delete m_activity;
	m_activity= NULL;
}


/*!
 * Member initialisation
 */

void PlayWithVoiceDialog::Init()
{
////@begin PlayWithVoiceDialog member initialisation
    m_btnMicInput = NULL;
    m_sldMicInput = NULL;
    m_gaugeMicInput = NULL;
    m_btnSoundOutput = NULL;
    m_sldOutput = NULL;
    m_gaugeOutput = NULL;
    m_btnReverb = NULL;
    m_sldReverb = NULL;
    m_txtReverb = NULL;
    m_sldChorus = NULL;
    m_txtChorus = NULL;
    m_sldPitchShift = NULL;
    m_txtPitchShift = NULL;
    m_sldDistorsion = NULL;
    m_txtDistorsion = NULL;
    m_chkRobot = NULL;
    m_chkPhone = NULL;
    m_chkHowlingReduction = NULL;
    m_sldEchoDelay = NULL;
    m_txtEchoDelay = NULL;
    m_sldEchoPitchShift = NULL;
    m_txtEchoPitchShift = NULL;
////@end PlayWithVoiceDialog member initialisation
	m_activity= NULL;
	m_timer= NULL;
}


/*!
 * Control creation for PlayWithVoiceDialog
 */

void PlayWithVoiceDialog::CreateControls()
{    
////@begin PlayWithVoiceDialog content construction
    PlayWithVoiceDialog* itemMDIChildFrame1 = this;

    wxBoxSizer* itemBoxSizer2 = new wxBoxSizer(wxVERTICAL);
    itemMDIChildFrame1->SetSizer(itemBoxSizer2);

    wxStaticBox* itemStaticBoxSizer3Static = new wxStaticBox(itemMDIChildFrame1, wxID_ANY, _("Mic input"));
    wxStaticBoxSizer* itemStaticBoxSizer3 = new wxStaticBoxSizer(itemStaticBoxSizer3Static, wxVERTICAL);
    itemBoxSizer2->Add(itemStaticBoxSizer3, 0, wxGROW|wxALL, 5);

    wxGridBagSizer* itemGridBagSizer4 = new wxGridBagSizer(0, 0);
    itemGridBagSizer4->AddGrowableCol(1);
    itemGridBagSizer4->SetEmptyCellSize(wxSize(10, 20));
    itemStaticBoxSizer3->Add(itemGridBagSizer4, 0, wxGROW|wxALL, 5);

    m_btnMicInput = new wxBitmapButton;
    m_btnMicInput->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_MICINPUT, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer4->Add(m_btnMicInput, wxGBPosition(0, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldMicInput = new wxSlider;
    m_sldMicInput->Create( itemMDIChildFrame1, ID_SLIDER_MIC_INPUT, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer4->Add(m_sldMicInput, wxGBPosition(0, 1), wxGBSpan(1, 1), wxGROW|wxALIGN_CENTER_VERTICAL|wxLEFT|wxTOP, 5);

    m_gaugeMicInput = new wxGauge;
    m_gaugeMicInput->Create( itemMDIChildFrame1, ID_GAUGE_MIC_INPUT, 100, wxDefaultPosition, wxSize(-1, 15), wxGA_HORIZONTAL );
    m_gaugeMicInput->SetValue(0);
    itemGridBagSizer4->Add(m_gaugeMicInput, wxGBPosition(1, 0), wxGBSpan(1, 2), wxGROW|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticBox* itemStaticBoxSizer8Static = new wxStaticBox(itemMDIChildFrame1, wxID_ANY, _("Sound output"));
    wxStaticBoxSizer* itemStaticBoxSizer8 = new wxStaticBoxSizer(itemStaticBoxSizer8Static, wxVERTICAL);
    itemBoxSizer2->Add(itemStaticBoxSizer8, 0, wxGROW|wxALL, 5);

    wxGridBagSizer* itemGridBagSizer9 = new wxGridBagSizer(0, 0);
    itemGridBagSizer9->AddGrowableCol(1);
    itemGridBagSizer9->SetEmptyCellSize(wxSize(10, 20));
    itemStaticBoxSizer8->Add(itemGridBagSizer9, 0, wxGROW|wxALL, 5);

    m_btnSoundOutput = new wxBitmapButton;
    m_btnSoundOutput->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_SOUNDOUTPUT, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer9->Add(m_btnSoundOutput, wxGBPosition(0, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldOutput = new wxSlider;
    m_sldOutput->Create( itemMDIChildFrame1, ID_SLIDER_OUTPUT, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer9->Add(m_sldOutput, wxGBPosition(0, 1), wxGBSpan(1, 1), wxGROW|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT|wxTOP, 5);

    m_gaugeOutput = new wxGauge;
    m_gaugeOutput->Create( itemMDIChildFrame1, ID_GAUGE_OUTPUT, 100, wxDefaultPosition, wxSize(-1, 15), wxGA_HORIZONTAL );
    m_gaugeOutput->SetValue(1);
    itemGridBagSizer9->Add(m_gaugeOutput, wxGBPosition(1, 0), wxGBSpan(1, 2), wxGROW|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticBox* itemStaticBoxSizer13Static = new wxStaticBox(itemMDIChildFrame1, wxID_ANY, _("Effects"));
    wxStaticBoxSizer* itemStaticBoxSizer13 = new wxStaticBoxSizer(itemStaticBoxSizer13Static, wxVERTICAL);
    itemBoxSizer2->Add(itemStaticBoxSizer13, 0, wxGROW|wxALL, 5);

    wxGridBagSizer* itemGridBagSizer14 = new wxGridBagSizer(0, 0);
    itemGridBagSizer14->SetEmptyCellSize(wxSize(10, 20));
    itemStaticBoxSizer13->Add(itemGridBagSizer14, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText15 = new wxStaticText;
    itemStaticText15->Create( itemMDIChildFrame1, wxID_STATIC, _("Reverb:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer14->Add(itemStaticText15, wxGBPosition(0, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_btnReverb = new wxBitmapButton;
    m_btnReverb->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_REVERB, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer14->Add(m_btnReverb, wxGBPosition(0, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldReverb = new wxSlider;
    m_sldReverb->Create( itemMDIChildFrame1, ID_SLIDER_REVERB, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer14->Add(m_sldReverb, wxGBPosition(0, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtReverb = new wxTextCtrl;
    m_txtReverb->Create( itemMDIChildFrame1, ID_TEXTCTRL_REVERB, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer14->Add(m_txtReverb, wxGBPosition(0, 3), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText19 = new wxStaticText;
    itemStaticText19->Create( itemMDIChildFrame1, wxID_STATIC, _("Chorus:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer14->Add(itemStaticText19, wxGBPosition(1, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBitmapButton* itemBitmapButton20 = new wxBitmapButton;
    itemBitmapButton20->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_CHORUS, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer14->Add(itemBitmapButton20, wxGBPosition(1, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldChorus = new wxSlider;
    m_sldChorus->Create( itemMDIChildFrame1, ID_SLIDER_CHORUS, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer14->Add(m_sldChorus, wxGBPosition(1, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtChorus = new wxTextCtrl;
    m_txtChorus->Create( itemMDIChildFrame1, ID_TEXTCTRL_CHORUS, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer14->Add(m_txtChorus, wxGBPosition(1, 3), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText23 = new wxStaticText;
    itemStaticText23->Create( itemMDIChildFrame1, wxID_STATIC, _("Pitch shift:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer14->Add(itemStaticText23, wxGBPosition(2, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBitmapButton* itemBitmapButton24 = new wxBitmapButton;
    itemBitmapButton24->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_PITCHSHIFT, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer14->Add(itemBitmapButton24, wxGBPosition(2, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldPitchShift = new wxSlider;
    m_sldPitchShift->Create( itemMDIChildFrame1, ID_SLIDER_PITCHSHIFT, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer14->Add(m_sldPitchShift, wxGBPosition(2, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtPitchShift = new wxTextCtrl;
    m_txtPitchShift->Create( itemMDIChildFrame1, ID_TEXTCTRL_PITCHSHIFT, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer14->Add(m_txtPitchShift, wxGBPosition(2, 3), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText27 = new wxStaticText;
    itemStaticText27->Create( itemMDIChildFrame1, wxID_STATIC, _("Distorsion:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer14->Add(itemStaticText27, wxGBPosition(3, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBitmapButton* itemBitmapButton28 = new wxBitmapButton;
    itemBitmapButton28->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_DISTORSION, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer14->Add(itemBitmapButton28, wxGBPosition(3, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldDistorsion = new wxSlider;
    m_sldDistorsion->Create( itemMDIChildFrame1, ID_SLIDER_DISTORSION, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer14->Add(m_sldDistorsion, wxGBPosition(3, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtDistorsion = new wxTextCtrl;
    m_txtDistorsion->Create( itemMDIChildFrame1, ID_TEXTCTRL_DISTORSION, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer14->Add(m_txtDistorsion, wxGBPosition(3, 3), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxGridSizer* itemGridSizer31 = new wxGridSizer(0, 2, 0, 0);
    itemStaticBoxSizer13->Add(itemGridSizer31, 0, wxGROW|wxALL, 5);

    m_chkRobot = new wxCheckBox;
    m_chkRobot->Create( itemMDIChildFrame1, ID_CHECKBOX_ROBOT, _("Robot"), wxDefaultPosition, wxDefaultSize, 0 );
    m_chkRobot->SetValue(false);
    itemGridSizer31->Add(m_chkRobot, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_chkPhone = new wxCheckBox;
    m_chkPhone->Create( itemMDIChildFrame1, ID_CHECKBOX_PHONE, _("Phone sound"), wxDefaultPosition, wxDefaultSize, 0 );
    m_chkPhone->SetValue(false);
    itemGridSizer31->Add(m_chkPhone, 0, wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    m_chkHowlingReduction = new wxCheckBox;
    m_chkHowlingReduction->Create( itemMDIChildFrame1, ID_CHECKBOX_HOWLINGREDUCTION, _("Howling reduction"), wxDefaultPosition, wxDefaultSize, 0 );
    m_chkHowlingReduction->SetValue(false);
    itemGridSizer31->Add(m_chkHowlingReduction, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxGridBagSizer* itemGridBagSizer35 = new wxGridBagSizer(0, 0);
    itemGridBagSizer35->SetEmptyCellSize(wxSize(10, 20));
    itemStaticBoxSizer13->Add(itemGridBagSizer35, 0, wxALIGN_LEFT|wxALL, 5);

    wxStaticText* itemStaticText36 = new wxStaticText;
    itemStaticText36->Create( itemMDIChildFrame1, wxID_STATIC, _("Echo"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer35->Add(itemStaticText36, wxGBPosition(0, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxStaticLine* itemStaticLine37 = new wxStaticLine;
    itemStaticLine37->Create( itemMDIChildFrame1, wxID_STATIC, wxDefaultPosition, wxSize(-1, 1), wxLI_HORIZONTAL );
    itemGridBagSizer35->Add(itemStaticLine37, wxGBPosition(1, 0), wxGBSpan(1, 5), wxGROW|wxALIGN_TOP|wxALL|wxFIXED_MINSIZE, 5);

    wxStaticText* itemStaticText38 = new wxStaticText;
    itemStaticText38->Create( itemMDIChildFrame1, wxID_STATIC, _("Delay:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer35->Add(itemStaticText38, wxGBPosition(2, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBitmapButton* itemBitmapButton39 = new wxBitmapButton;
    itemBitmapButton39->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_ECHODELAY, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer35->Add(itemBitmapButton39, wxGBPosition(2, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldEchoDelay = new wxSlider;
    m_sldEchoDelay->Create( itemMDIChildFrame1, ID_SLIDER_ECHODELAY, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer35->Add(m_sldEchoDelay, wxGBPosition(2, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtEchoDelay = new wxTextCtrl;
    m_txtEchoDelay->Create( itemMDIChildFrame1, ID_TEXTCTRL_ECHODELAY, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer35->Add(m_txtEchoDelay, wxGBPosition(2, 3), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    wxStaticText* itemStaticText42 = new wxStaticText;
    itemStaticText42->Create( itemMDIChildFrame1, wxID_STATIC, _("s"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer35->Add(itemStaticText42, wxGBPosition(2, 4), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxRIGHT|wxTOP|wxBOTTOM, 5);

    wxStaticText* itemStaticText43 = new wxStaticText;
    itemStaticText43->Create( itemMDIChildFrame1, wxID_STATIC, _("Pitch shift:"), wxDefaultPosition, wxDefaultSize, 0 );
    itemGridBagSizer35->Add(itemStaticText43, wxGBPosition(3, 0), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxALL, 5);

    wxBitmapButton* itemBitmapButton44 = new wxBitmapButton;
    itemBitmapButton44->Create( itemMDIChildFrame1, ID_BITMAPBUTTON_ECHOPITCHSHIFT, itemMDIChildFrame1->GetBitmapResource(wxT("bitmaps/disable_icon.xpm")), wxDefaultPosition, wxDefaultSize, wxBU_AUTODRAW );
    itemGridBagSizer35->Add(itemBitmapButton44, wxGBPosition(3, 1), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxALL, 0);

    m_sldEchoPitchShift = new wxSlider;
    m_sldEchoPitchShift->Create( itemMDIChildFrame1, ID_SLIDER_ECHOPITCHSHIFT, 0, 0, 200, wxDefaultPosition, wxDefaultSize, wxSL_HORIZONTAL );
    itemGridBagSizer35->Add(m_sldEchoPitchShift, wxGBPosition(3, 2), wxGBSpan(1, 1), wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL|wxLEFT, 0);

    m_txtEchoPitchShift = new wxTextCtrl;
    m_txtEchoPitchShift->Create( itemMDIChildFrame1, ID_TEXTCTRL_ECHOPITCHSHIFT, wxEmptyString, wxDefaultPosition, wxSize(40, -1), wxTE_READONLY|wxTE_RIGHT );
    itemGridBagSizer35->Add(m_txtEchoPitchShift, wxGBPosition(3, 3), wxGBSpan(1, 1), wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL|wxLEFT|wxRIGHT, 5);

    // Connect events and objects
    itemMDIChildFrame1->Connect(ID_PLAYWITHVOICEDIALOG, wxEVT_DESTROY, wxWindowDestroyEventHandler(PlayWithVoiceDialog::OnDestroy), NULL, this);
////@end PlayWithVoiceDialog content construction

	assert (m_activity== NULL);
	m_activity= new CPVoiceActivity ();

	m_sldMicInput->SetRange (m_activity->getMicInputControl()->getMin(), m_activity->getMicInputControl()->getMax());
	m_sldMicInput->SetValue (m_activity->getMicInputControl()->getValue());
	UpdateSliderEvent(ID_SLIDER_MIC_INPUT);
	m_gaugeMicInput->SetRange (100);

	m_sldOutput->SetRange (m_activity->getOutputControl()->getMin(), m_activity->getOutputControl()->getMax());
	m_sldOutput->SetValue (m_activity->getOutputControl()->getValue());
	UpdateSliderEvent(ID_SLIDER_OUTPUT);	
	m_gaugeOutput->SetRange (100);

	m_sldReverb->SetRange (m_activity->getReverb()->getMin(), m_activity->getReverb()->getMax());
	m_sldReverb->SetValue (m_activity->getReverb()->getValue());
	UpdateSliderEvent(ID_SLIDER_REVERB);	

	m_sldChorus->SetRange (m_activity->getChorus()->getMin(), m_activity->getChorus()->getMax());
	m_sldChorus->SetValue (m_activity->getChorus()->getValue());
	UpdateSliderEvent(ID_SLIDER_CHORUS);

	m_sldPitchShift->SetRange (m_activity->getPitchShift()->getMin(), m_activity->getPitchShift()->getMax());
	m_sldPitchShift->SetValue (m_activity->getPitchShift()->getValue());
	UpdateSliderEvent(ID_SLIDER_PITCHSHIFT);

	m_sldDistorsion->SetRange (m_activity->getDistorsion()->getMin(), m_activity->getDistorsion()->getMax());
	m_sldDistorsion->SetValue (m_activity->getDistorsion()->getValue());
	UpdateSliderEvent(ID_SLIDER_DISTORSION);

	m_chkRobot->SetValue (m_activity->getRobot());
	m_chkPhone->SetValue (m_activity->getPhone());
	m_chkHowlingReduction->SetValue (m_activity->getHowlingReduction());

	m_sldEchoDelay->SetRange (m_activity->getEchoDelay()->getMin(), m_activity->getEchoDelay()->getMax());
	m_logExpRangeEchoDelay.setParams (	(float) m_activity->getEchoDelay()->getMax(), 
										(float) m_activity->getEchoDelay()->getMax(), 4.0f);
	m_sldEchoDelay->SetValue ( (int) m_logExpRangeEchoDelay.ToLog ((float) m_activity->getEchoDelay()->getValue()));
	UpdateSliderEvent(ID_SLIDER_ECHODELAY);
	

	m_sldEchoPitchShift->SetRange (m_activity->getEchoPitchShift()->getMin(), m_activity->getEchoPitchShift()->getMax());
	m_sldEchoPitchShift->SetValue (m_activity->getEchoPitchShift()->getValue());
	UpdateSliderEvent(ID_SLIDER_ECHOPITCHSHIFT);

	m_activity->Run();
	m_timer= new wxTimer(this, TIMER_ID);
	m_timer->Start (33);
}


/*!
 * Should we show tooltips?
 */

bool PlayWithVoiceDialog::ShowToolTips()
{
    return true;
}

/*!
 * Get bitmap resources
 */

wxBitmap PlayWithVoiceDialog::GetBitmapResource( const wxString& name )
{
    // Bitmap retrieval
////@begin PlayWithVoiceDialog bitmap retrieval
    wxUnusedVar(name);
    if (name == _T("bitmaps/disable_icon.xpm"))
    {
        wxBitmap bitmap(disable_icon);
        return bitmap;
    }
    return wxNullBitmap;
////@end PlayWithVoiceDialog bitmap retrieval
}

/*!
 * Get icon resources
 */

wxIcon PlayWithVoiceDialog::GetIconResource( const wxString& name )
{
    // Icon retrieval
////@begin PlayWithVoiceDialog icon retrieval
    wxUnusedVar(name);
    return wxNullIcon;
////@end PlayWithVoiceDialog icon retrieval
}

/*
// Converts sound envelope in dB (range 0,112) to VU meter scale (0,100)
// TODO: refactor to build a VU meter control
float PlayWithVoiceDialog::Envelope2VUMeter(float env)
{
	float val, result;
	
	// VU meter like 

	// Input env's range is 0..112 dB, where 100dB is envelope RMS=1.
	// see [env~] object in pure data for further details

	// modify envelope to get negative values when maximum is not reached
	// and positive values for a signal over maximum
	env-= 100;

	// 66% of gauge (from 0 to 75) is for negative db
	if (env>= 0)
	{
		// Positive part

		// compute log. result is in the range [0, 2.5)
		val= log (1.0f + env);
		
		// map log result to gauge
		result= 66.0f + (34.0f / 2.5f) * val;
	}
	else
	{
		// Negative part		
		val= log (1.0f - env);	// range [0, 4,62)
		result= 66.0f - (66.0f / 4.62f) * val;
	}

	// ensure right gauge range
	assert (result>= 0);
	if (result> 100.0f) result= 100.0f;

	return result;
}*/

// Send a wxECVT_COMMAND_SLIDER_UPDATED event
void PlayWithVoiceDialog::UpdateSliderEvent(int id)
{
	wxCommandEvent evt (wxEVT_COMMAND_SLIDER_UPDATED, id);
	GetEventHandler()->ProcessEvent( evt );
}

// Show a float number in a text box
void PlayWithVoiceDialog::TextCtrlF (float v, wxTextCtrl* tb)
{
	wxString str;
	str.Printf (_T("%.2f"), v);
	tb->SetLabel (str);	
}

// Put the value of a slider into a text box
void PlayWithVoiceDialog::Slider2TextCtrl(wxSlider* slider, wxTextCtrl* tb)
{
	wxString str;
	str.Printf (_T("%d"), slider->GetValue());
	tb->SetLabel (str);	
}

// Put the value of a slider into a text box. Float version with optional scaling factor
void PlayWithVoiceDialog::Slider2TextCtrlF(wxSlider* slider, wxTextCtrl* tb, float fact)
{
	TextCtrlF (((float) slider->GetValue()) * fact, tb);
		/*
	wxString str;
	str.Printf (_T("%.2f"), ((float) slider->GetValue()) * fact);
	tb->SetLabel (str);	
	*/
}

void PlayWithVoiceDialog::OnTimer(wxTimerEvent& event)
{
	if (m_timer) {
		m_gaugeMicInput->SetValue ((int) Envelope2VUMeter(m_activity->getMicInputEnvelope()));
		m_gaugeOutput->SetValue ((int) Envelope2VUMeter(m_activity->getOutputEnvelope()));
	}
}

/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_MIC_INPUT
 */

void PlayWithVoiceDialog::OnSliderMicInputUpdated( wxCommandEvent& event )
{
	//Slider2TextCtrl(wxSlider* slider, wxTextCtrl* tb)
	m_activity->setMicInputControl (m_sldMicInput->GetValue());

	event.Skip (false);
}

/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_OUTPUT
 */

void PlayWithVoiceDialog::OnSliderOutputUpdated( wxCommandEvent& event )
{
	m_activity->setOutputControl (m_sldOutput->GetValue());

	event.Skip (false);
}

/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_REVERB
 */

void PlayWithVoiceDialog::OnBitmapbuttonReverbClick( wxCommandEvent& event )
{
	m_sldReverb->SetValue (m_activity->getReverb()->getDefault());
	UpdateSliderEvent(ID_SLIDER_REVERB); 

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_REVERB
 */

void PlayWithVoiceDialog::OnSliderReverbUpdated( wxCommandEvent& event )
{
	Slider2TextCtrl(m_sldReverb, m_txtReverb);
	m_activity->setReverb (m_sldReverb->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_CHORUS
 */

void PlayWithVoiceDialog::OnSliderChorusUpdated( wxCommandEvent& event )
{
	Slider2TextCtrl(m_sldChorus, m_txtChorus);
	m_activity->setChorus (m_sldChorus->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_CHORUS
 */

void PlayWithVoiceDialog::OnBitmapbuttonChorusClick( wxCommandEvent& event )
{
	m_sldChorus->SetValue (m_activity->getChorus()->getDefault());
	UpdateSliderEvent(ID_SLIDER_CHORUS); 

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_PITCHSHIFT
 */

void PlayWithVoiceDialog::OnBitmapbuttonPitchshiftClick( wxCommandEvent& event )
{
	m_sldPitchShift->SetValue (m_activity->getPitchShift()->getDefault());
	UpdateSliderEvent(ID_SLIDER_PITCHSHIFT); 

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_PITCHSHIFT
 */

void PlayWithVoiceDialog::OnSliderPitchshiftUpdated( wxCommandEvent& event )
{
	Slider2TextCtrlF(m_sldPitchShift, m_txtPitchShift, 0.01f);
	m_activity->setPitchShift (m_sldPitchShift->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_ROBOT
 */

void PlayWithVoiceDialog::OnCheckboxRobotClick( wxCommandEvent& event )
{
	m_activity->setRobot (m_chkRobot->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_PHONE
 */

void PlayWithVoiceDialog::OnCheckboxPhoneClick( wxCommandEvent& event )
{
	m_activity->setPhone (m_chkPhone->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_ECHODELAY
 */

void PlayWithVoiceDialog::OnBitmapbuttonEchodelayClick( wxCommandEvent& event )
{
//	m_sldEchoDelay->SetValue (m_activity->getEchoDelay()->getDefault());
	m_sldEchoDelay->SetValue ( (int) m_logExpRangeEchoDelay.ToLog ((float) m_activity->getEchoDelay()->getDefault()));
	UpdateSliderEvent(ID_SLIDER_ECHODELAY); 

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_ECHODELAY
 */

void PlayWithVoiceDialog::OnSliderEchodelayUpdated( wxCommandEvent& event )
{
	float toExp= m_logExpRangeEchoDelay.ToExp ((float) m_sldEchoDelay->GetValue());
	TextCtrlF (toExp/100.0f, m_txtEchoDelay);
	m_activity->setEchoDelay ((int) toExp);

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_ECHOPITCHSHIFT
 */

void PlayWithVoiceDialog::OnBitmapbuttonEchopitchshiftClick( wxCommandEvent& event )
{
	m_sldEchoPitchShift->SetValue (m_activity->getEchoPitchShift()->getDefault());
	UpdateSliderEvent(ID_SLIDER_ECHOPITCHSHIFT); 

	event.Skip (false); 
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_ECHOPITCHSHIFT
 */

void PlayWithVoiceDialog::OnSliderEchopitchshiftUpdated( wxCommandEvent& event )
{
	Slider2TextCtrlF(m_sldEchoPitchShift, m_txtEchoPitchShift, 0.01f);
	m_activity->setEchoPitchShift (m_sldEchoPitchShift->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON
 */

void PlayWithVoiceDialog::OnBitmapbuttonMicinputClick( wxCommandEvent& event )
{
	m_sldMicInput->SetValue (m_activity->getMicInputControl()->getDefault());
	UpdateSliderEvent(ID_SLIDER_MIC_INPUT); 

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_SOUNDOUTPUT
 */

void PlayWithVoiceDialog::OnBitmapbuttonSoundoutputClick( wxCommandEvent& event )
{
	m_sldOutput->SetValue (m_activity->getOutputControl()->getDefault());
	UpdateSliderEvent(ID_SLIDER_OUTPUT);

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BITMAPBUTTON_DISTORSION
 */

void PlayWithVoiceDialog::OnBitmapbuttonDistorsionClick( wxCommandEvent& event )
{
	m_sldDistorsion->SetValue (m_activity->getDistorsion()->getDefault());
	UpdateSliderEvent(ID_SLIDER_DISTORSION);

    event.Skip(false);
}


/*!
 * wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_DISTORSION
 */

void PlayWithVoiceDialog::OnSliderDistorsionUpdated( wxCommandEvent& event )
{
	Slider2TextCtrl(m_sldDistorsion, m_txtDistorsion);
	m_activity->setDistorsion (m_sldDistorsion->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_HOWLINGREDUCTION
 */

void PlayWithVoiceDialog::OnCheckboxHowlingreductionClick( wxCommandEvent& event )
{
	m_activity->setHowlingReduction (m_chkHowlingReduction->GetValue());

	event.Skip (false);
}


/*!
 * wxEVT_CLOSE_WINDOW event handler for ID_PLAYWITHVOICEDIALOG
 */

void PlayWithVoiceDialog::OnCloseWindow( wxCloseEvent& event )
{
	//delete m_timer;
	Destroy();
	event.Skip (false);
}


/*!
 * wxEVT_DESTROY event handler for ID_PLAYWITHVOICEDIALOG
 */

void PlayWithVoiceDialog::OnDestroy( wxWindowDestroyEvent& event )
{
//	assert (m_activity);
	
//	m_activity->Finish();
//	m_activity->Wait();
	//delete m_activity;
//	m_activity= NULL;

    event.Skip(false);
}

