/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     25/02/2010 21:02:14
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#ifndef _PUREDATATESTW_H_
#define _PUREDATATESTW_H_


/*!
 * Includes
 */

////@begin includes
#include "wx/spinctrl.h"
#include "wx/collpane.h"
////@end includes
#include <wx/wx.h>
#include "logexprange.h"
#include "testpd.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
class wxSpinCtrl;
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_CPUREDATATESTW 10039
#define ID_SPINCTRL_DELAY 10040
#define ID_RADIOBUTTON_PLAYSOUND 10041
#define ID_RADIOBUTTON_MIC 10042
#define ID_SLIDER_MICVOL 10043
#define ID_GAUGE_MICINPUT 10049
#define ID_SLIDER_OUTVOL 10044
#define ID_GAUGE_OUTVOL 10000
#define ID_COLLAPSIBLEPANE 10048
#define ID_CHECKBOX_PD_GUI 10046
#define ID_CHECKBOX_DEBUG_CONSOLE 10045
#define ID_BUTTON_CLOSE 10047
#define SYMBOL_CPUREDATATESTW_STYLE wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU|wxCLOSE_BOX|wxTAB_TRAVERSAL
#define SYMBOL_CPUREDATATESTW_TITLE _("Sound test")
#define SYMBOL_CPUREDATATESTW_IDNAME ID_CPUREDATATESTW
#define SYMBOL_CPUREDATATESTW_SIZE wxSize(400, 300)
#define SYMBOL_CPUREDATATESTW_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CPureDataTestW class declaration
 */

class CPureDataTestW: public wxDialog
{    
    DECLARE_DYNAMIC_CLASS( CPureDataTestW )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
    CPureDataTestW();
    CPureDataTestW( wxWindow* parent, wxWindowID id = SYMBOL_CPUREDATATESTW_IDNAME, const wxString& caption = SYMBOL_CPUREDATATESTW_TITLE, const wxPoint& pos = SYMBOL_CPUREDATATESTW_POSITION, const wxSize& size = SYMBOL_CPUREDATATESTW_SIZE, long style = SYMBOL_CPUREDATATESTW_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CPUREDATATESTW_IDNAME, const wxString& caption = SYMBOL_CPUREDATATESTW_TITLE, const wxPoint& pos = SYMBOL_CPUREDATATESTW_POSITION, const wxSize& size = SYMBOL_CPUREDATATESTW_SIZE, long style = SYMBOL_CPUREDATATESTW_STYLE );

    /// Destructor
    ~CPureDataTestW();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CPureDataTestW event handler declarations

    /// wxEVT_CLOSE_WINDOW event handler for ID_CPUREDATATESTW
    void OnCloseWindow( wxCloseEvent& event );

    /// wxEVT_DESTROY event handler for ID_CPUREDATATESTW
    void OnDestroy( wxWindowDestroyEvent& event );

    /// wxEVT_COMMAND_SPINCTRL_UPDATED event handler for ID_SPINCTRL_DELAY
    void OnSpinctrlDelayUpdated( wxSpinEvent& event );

    /// wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_RADIOBUTTON_PLAYSOUND
    void OnRadiobuttonPlaysoundSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_RADIOBUTTON_SELECTED event handler for ID_RADIOBUTTON_MIC
    void OnRadiobuttonMicSelected( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_MICVOL
    void OnSliderMicvolUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_SLIDER_UPDATED event handler for ID_SLIDER_OUTVOL
    void OnSliderOutvolUpdated( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_PD_GUI
    void OnCheckboxPdGuiClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_CHECKBOX_CLICKED event handler for ID_CHECKBOX_DEBUG_CONSOLE
    void OnCheckboxDebugConsoleClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_CLOSE
    void OnButtonCloseClick( wxCommandEvent& event );

////@end CPureDataTestW event handler declarations
	void OnTimer(wxTimerEvent& event);

////@begin CPureDataTestW member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CPureDataTestW member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

private:
////@begin CPureDataTestW member variables
    wxSpinCtrl* m_spinDelay;
    wxStaticText* m_txtMicVol;
    wxSlider* m_sldMicVol;
    wxGauge* m_gaugeMicInput;
    wxSlider* m_sldOutVol;
    wxGauge* m_gaugeOutput;
    wxCheckBox* m_chkGUIDebug;
    wxCheckBox* m_chkDebugConsole;
////@end CPureDataTestW member variables
	CTestPD m_activity;
	wxTimer m_timer;
	bool m_micTest;	
};

#endif
    // _PUREDATATESTW_H_
