/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     31/12/2009 19:08:58
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////
#ifndef _SIMPLESHAPEDRAWERDIALOG_H_
#define _SIMPLESHAPEDRAWERDIALOG_H_


/*!
 * Includes
 */

////@begin includes
////@end includes

#include "SimpleShapeDrawer.h"

/*!
 * Forward declarations
 */

////@begin forward declarations
////@end forward declarations

/*!
 * Control identifiers
 */

////@begin control identifiers
#define ID_SIMPLESHAPEDRAWERDIALOG 10019
#define ID_BUTTON_PREV_SHAPE 10002
#define ID_TEXTCTRL_SHAPE 10003
#define ID_BUTTON_NEXT_SHAPE 10004
#define SYMBOL_CSIMPLESHAPEDRAWERDIALOG_STYLE wxNO_BORDER|wxTAB_TRAVERSAL
#define SYMBOL_CSIMPLESHAPEDRAWERDIALOG_TITLE _("SimpleShapeDrawerDialog")
#define SYMBOL_CSIMPLESHAPEDRAWERDIALOG_IDNAME ID_SIMPLESHAPEDRAWERDIALOG
#define SYMBOL_CSIMPLESHAPEDRAWERDIALOG_SIZE wxSize(400, 300)
#define SYMBOL_CSIMPLESHAPEDRAWERDIALOG_POSITION wxDefaultPosition
////@end control identifiers


/*!
 * CSimpleShapeDrawerDialog class declaration
 */

class CSimpleShapeDrawerDialog: public wxPanel
{    
    DECLARE_DYNAMIC_CLASS( CSimpleShapeDrawerDialog )
    DECLARE_EVENT_TABLE()

public:
    /// Constructors
	CSimpleShapeDrawerDialog();
    //CSimpleShapeDrawerDialog( wxWindow* parent, CSimpleShapeDrawer* ssd)
	CSimpleShapeDrawerDialog( CSimpleShapeDrawer* ssd);
    CSimpleShapeDrawerDialog( wxWindow* parent, wxWindowID id = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_IDNAME,  const wxPoint& pos = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_POSITION, const wxSize& size = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_SIZE, long style = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_STYLE );

    /// Creation
    bool Create( wxWindow* parent, wxWindowID id = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_IDNAME, const wxPoint& pos = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_POSITION, const wxSize& size = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_SIZE, long style = SYMBOL_CSIMPLESHAPEDRAWERDIALOG_STYLE );

    /// Destructor
    ~CSimpleShapeDrawerDialog();

    /// Initialises member variables
    void Init();

    /// Creates the controls and sizers
    void CreateControls();

////@begin CSimpleShapeDrawerDialog event handler declarations

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_PREV_SHAPE
    void OnButtonPrevShapeClick( wxCommandEvent& event );

    /// wxEVT_COMMAND_BUTTON_CLICKED event handler for ID_BUTTON_NEXT_SHAPE
    void OnButtonNextShapeClick( wxCommandEvent& event );

////@end CSimpleShapeDrawerDialog event handler declarations

////@begin CSimpleShapeDrawerDialog member function declarations

    /// Retrieves bitmap resources
    wxBitmap GetBitmapResource( const wxString& name );

    /// Retrieves icon resources
    wxIcon GetIconResource( const wxString& name );
////@end CSimpleShapeDrawerDialog member function declarations

    /// Should we show tooltips?
    static bool ShowToolTips();

////@begin CSimpleShapeDrawerDialog member variables
    wxButton* m_btnPrevShape;
    wxTextCtrl* m_txtCurrentShape;
    wxButton* m_btnNextShape;
////@end CSimpleShapeDrawerDialog member variables
private:

	void UpdateShape();

	CSimpleShapeDrawer* m_pSimpleShapeDrawer;
	wxTimer m_timer;
};

#endif
    // _SIMPLESHAPEDRAWERDIALOG_H_
