/////////////////////////////////////////////////////////////////////////////
// Name:       
// Purpose:  
// Author:      Cesar Mauri Loba (cesar at crea-si dot com)
// Modified by: 
// Created:     
// Copyright:   (C) 2010 Cesar Mauri Loba - CREA Software Systems
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
/////////////////////////////////////////////////////////////////////////////

#include "testpd.h"
#include <exception>
#include "exceptions.h"
//#include <wx/msgdlg.h>
#include <wx/intl.h>
//#include <SDL_gfxPrimitives.h>
#include <iostream>

CTestPD::CTestPD() : //wxThreadKind kind) : 
  m_oscIn(50003, this)
, m_oscOut(50002)
, m_patch(_T("testpd.pd"))
//	CBaseActivity (kind, -1, _T("testpd.pd"), false, false, 50002, false, 20)
//, m_socket(NULL)
, m_micInputControl (25,0,200,0)
, m_micInputEnvelope(0)
, m_outputControl (25,0,200,0)
, m_outputEnvelope (0)
{	
		
}

CTestPD::~CTestPD(void)
{
	Finish();
}

void CTestPD::ProcessMessage( const osc::ReceivedMessage& m, const IpEndpointName& remoteEndpoint )
{
	try{
		if( strcmp( m.AddressPattern(), "/testpd" ) == 0 )
		{
//			float pitch; 
			//bool attack;

			//osc::ReceivedMessageArgumentStream args = m.ArgumentStream();
			//args >> inEnv >> outEnv >> pitch >> osc::EndMessage;

			osc::ReceivedMessage::const_iterator arg = m.ArgumentsBegin();
			if (arg->IsInt32())
				m_micInputEnvelope= (float) (arg++)->AsInt32();
			else
				m_micInputEnvelope= (arg++)->AsFloat();

			if (arg->IsInt32())
				m_outputEnvelope = (float) (arg++)->AsInt32();
			else
				m_outputEnvelope = (arg++)->AsFloat();

				/*
			if (arg->IsInt32())
				pitch = (float) (arg++)->AsInt32();
			else
				pitch = (arg++)->AsFloat();
			     
			attack= (bool) (arg++)->AsInt32();           
				*/
		}
		else
		{
//			std::cout << "Received unknown message\n";
		}
	}
	catch ( osc::Exception& e ){
        // any parsing errors such as unexpected argument types, or 
        // missing arguments get thrown as exceptions.
        std::cout << "error while parsing message: " << m.AddressPattern() << ": " << e.what() << "\n";
	}

//	if (!ContinueLoop()) m_socket->Break();
}

void CTestPD::Start()
{
	m_oscIn.Run(true);
}

void CTestPD::Finish()
{
	m_oscIn.Close();
//	if (m_socket) m_socket->AsynchronousBreak();
//	CBaseActivity::Finish();
}

/*
void CTestPD::Delete()
{
	//if (m_socket) m_socket->AsynchronousBreak();

	CBaseActivity::Delete();
}*/
/*
void CTestPD::MainLoop(void)
{
	try{
		m_socket= new UdpListeningReceiveSocket(IpEndpointName( IpEndpointName::ANY_ADDRESS, 50003 ), this );
		//std::cout << "listening for input on port\n";		
		m_socket->Run ();		
	}
	catch (...)
	{
		if (m_socket) delete m_socket;		
		m_socket= NULL;
		throw;
	}
	if (m_socket) delete m_socket;
	m_socket= NULL;
}

*/
